`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/11/2024 01:32:34 PM
// Design Name: 
// Module Name: ex8var
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module ex8var#(parameter VARS=8, LEN=12)(
   input [35:0] Co_1, Co_2, Co_3,/* Co_4, Co_5, Co_6, Co_7, Co_8, Co_9, Co_10,*/
    output reg [LEN:0] terms_f 
    );
    reg [7:0] terms=8'd0;
    reg solved;
    reg X1=1'b0;
    reg X2=1'b0;
    reg X3=1'b0;
    reg X4=1'b0;
    reg X5=1'b0;
    reg X6=1'b0;
    reg X7=1'b0;
    reg X8=1'b0;
    
    //for number of equations
    reg result_1, result_2, result_3, result_4, result_5, result_6, result_7, result_8, result_9, result_10;
        reg x1x2; reg x1x3;
        reg x1x4;reg x1x5;reg x1x6;
        reg x1x7;reg x1x8;reg x2x3;
        reg x2x4;reg x2x5;reg x2x6;
        reg x2x7;reg x2x8;reg x3x4;
        reg x3x5;reg x3x6;reg x3x7;
        reg x3x8; reg x4x5;reg x4x6;
        reg x4x7;reg x4x8; reg x5x6;
        reg x5x7;reg x5x8;reg x6x7;
        reg x6x8;reg x7x8;
        
    integer x;
     integer MAX=2**VARS;
     always @(*) begin
  for (x=0; x<MAX; x=x+1) begin
  //first, assign the linear x terms
  X1=terms[7]; X2=terms[6]; X3=terms[5];X4=terms[4]; X5=terms[3]; X6=terms[2];
  X7=terms[1];
  X8=terms[0];
  //assign the quadratics through the previous linear terms
  x1x2=X1& X2; x1x3=X1&X3; 
  x1x4=X1&X4; x1x5=X1&X5; x1x6= X1& X6;
   x1x7=X1 & X7; x1x8=X1&X8;x2x3=X2&X3;
        x2x4=X2&X4; x2x5=X2&X5; x2x6=X2&X6;
         x2x7=X2&X7; x2x8=X2&X8;x3x4=X3&X4;
         x3x5=X3&X5; x3x6=X3&X6; x3x7=X3&X7;
        x3x8=X3&X8; x4x5=X4&X5;x4x6=X4&X6;
        x4x7=X4&X7;x4x8=X4&X8; x5x6=X5&X6;
        x5x7=X5&X7;x5x8=X5&X8;x6x7=X6&X7;
        x6x8=X6&X8;x7x8=X7&X8;
   //solving for equations, comment out as needed
  result_1 = (x7x8 & Co_1[1]) ^ (x6x8 & Co_1[2])
       ^(x6x7 & Co_1[3]) ^ (x5x8 & Co_1[4]) ^(x5x7 & Co_1[5]) ^
       (x5x6 & Co_1[6]) ^(x4x8 & Co_1[7]) ^(x4x7 & Co_1[8]) ^
       (x4x6 & Co_1[9]) ^(x4x5 & Co_1[10]) ^(x3x8 & Co_1[11]) ^
       (x3x7 & Co_1[12]) ^(x3x6 & Co_1[13]) ^(x3x5 & Co_1[14]) ^
       (x3x4 & Co_1[15]) ^(x2x8 & Co_1[16]) ^(x2x7 & Co_1[17]) ^
       (x2x6 & Co_1[18]) ^(x2x5 & Co_1[19]) ^(x2x4 & Co_1[20]) ^
       (x2x3 & Co_1[21]) ^(x1x8 & Co_1[22]) ^(x1x7 & Co_1[23]) ^
       (x1x6 & Co_1[24]) ^(x1x5 & Co_1[25]) ^(x1x4 & Co_1[26]) ^
       (x1x3 & Co_1[27]) ^(x1x2 & Co_1[28]) ^(X8 & Co_1[29])
       ^(X7 & Co_1[30]) ^(X6 & Co_1[31]) ^(X5 & Co_1[32])
       ^(X4 & Co_1[33]) ^(X3 & Co_1[34]) ^(X2 & Co_1[35]) ^(X1 & Co_1[36]);
       
   result_2 = (x7x8 & Co_2[1]) ^ (x6x8 & Co_2[2])
     ^(x6x7 & Co_2[3]) ^ (x5x8 & Co_2[4]) ^(x5x7 & Co_2[5]) ^
     (x5x6 & Co_2[6]) ^(x4x8 & Co_2[7]) ^(x4x7 & Co_2[8]) ^
     (x4x6 & Co_2[9]) ^(x4x5 & Co_2[10]) ^(x3x8 & Co_2[11]) ^
     (x3x7 & Co_2[12]) ^(x3x6 & Co_2[13]) ^(x3x5 & Co_2[14]) ^
     (x3x4 & Co_2[15]) ^(x2x8 & Co_2[16]) ^(x2x7 & Co_2[17]) ^
     (x2x6 & Co_2[18]) ^(x2x5 & Co_2[19]) ^(x2x4 & Co_2[20]) ^
     (x2x3 & Co_2[21]) ^(x1x8 & Co_2[22]) ^(x1x7 & Co_2[23]) ^
     (x1x6 & Co_2[24]) ^(x1x5 & Co_2[25]) ^(x1x4 & Co_2[26]) ^
     (x1x3 & Co_2[27]) ^(x1x2 & Co_2[28])^(X8 & Co_2[29])
       ^(X7 & Co_2[30]) ^(X6 & Co_2[31]) ^(X5 & Co_2[32])
       ^(X4 & Co_2[33]) ^(X3 & Co_2[34]) ^(X2 & Co_2[35]) ^(X1 & Co_2[36]);
  result_3 = (x7x8 & Co_3[1]) ^ (x6x8 & Co_3[2])
     ^(x6x7 & Co_3[3]) ^ (x5x8 & Co_3[4]) ^(x5x7 & Co_3[5]) ^
     (x5x6 & Co_3[6]) ^(x4x8 & Co_3[7]) ^(x4x7 & Co_3[8]) ^
     (x4x6 & Co_3[9]) ^(x4x5 & Co_3[10]) ^(x3x8 & Co_3[11]) ^
     (x3x7 & Co_3[12]) ^(x3x6 & Co_3[13]) ^(x3x5 & Co_3[14]) ^
     (x3x4 & Co_3[15]) ^(x2x8 & Co_3[16]) ^(x2x7 & Co_3[17]) ^
     (x2x6 & Co_3[18]) ^(x2x5 & Co_3[19]) ^(x2x4 & Co_3[20]) ^
     (x2x3 & Co_3[21]) ^(x1x8 & Co_3[22]) ^(x1x7 & Co_3[23]) ^
     (x1x6 & Co_3[24]) ^(x1x5 & Co_3[25]) ^(x1x4 & Co_3[26]) ^
     (x1x3 & Co_3[27]) ^(x1x2 & Co_3[28])^(X8 & Co_3[29])
       ^(X7 & Co_3[30]) ^(X6 & Co_3[31]) ^(X5 & Co_3[32])
       ^(X4 & Co_3[33]) ^(X3 & Co_3[34]) ^(X2 & Co_3[35]) ^(X1 & Co_3[36]);
       
       //Solver to check if coeffs and vars = RHS
     solved = ( (result_1 == Co_1[37])&(result_2==Co_2[37])&(result_3==Co_3[37]))
       ? 1'b1 : 1'b0;
      if(solved==1'b1) begin
       terms_f={terms_f, terms};
      terms_f={terms_f, 1'b0};
      end
   //   else begin
 //     terms_f={terms_f, 3'bZZZ};
 //     end
      terms=terms+1'b1;
  end// for
  end// always
endmodule
