`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: WPI
// Engineer: 
// 
// Create Date: 11/04/2023 11:41:37 PM
// Design Name: 
// Module Name: top_level
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// Top level MQP work
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// 11/6- basic set up, debounce, clock set up
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top_level(
     input CLK,
    input [4:0] BTN, /*BTN[0]=btnc,BTN[1]=btnd,BTN[2]=btnl,BTN[3]=btnr,BTN[4]=btnu*/
    input [7:0] SW,
    input RSTN,
    output [7:0] LED,
    output UART_TXD
    );
    
    wire clk_100;
    wire reset;
    wire btnC_deb;
    wire btnD_deb;
    wire bntL_deb;
    wire btnR_deb;
    wire btnU_deb;

 clk_wiz_0 instance_name
   (  .clk_100(clk_100),     // output clk_100
    .reset(RSTN), // input reset
    .locked(reset),       // output locked
    .clk_in1(CLK));      // input clk_in1
    
    //debounce buttons
    debounce btnC_debounce (.in(BTN[0]),.out(btnC_deb),.clk(clk_100),.reset_n(RSTN));
    debounce btnD_debounce (.in(BTN[1]),.out(btnD_deb),.clk(clk_100),.reset_n(RSTN));
    debounce btnL_debounce (.in(BTN[2]),.out(btnL_deb),.clk(clk_100),.reset_n(RSTN));
    debounce btnR_debounce (.in(BTN[3]),.out(btnR_deb),.clk(clk_100),.reset_n(RSTN));
    debounce btnU_debounce (.in(BTN[4]),.out(btnU_deb),.clk(clk_100),.reset_n(RSTN));
    wire [4:0] btn_deb={btnC_deb, btnD_deb, btnL_deb, btnR_deb, btnU_deb};

   
 
  wire [7:0] EQ_f1=8'bX0001101;

  
  
 wire [36:0] EQ8_1=37'bX010101010101010101010101010101010100;
 wire [36:0] EQ8_2=37'bX010101010101010101010101010101010100;
 wire [36:0] EQ8_3=37'bX010101010101010101010101010101010100;
  //string to hold all equations together, make sure to include the X values to be overwritten
  //num eqs* bits -1 ex 2 of 8'b and 8'b is len of 15

 wire [105:0] EQ_8s={EQ8_1, EQ8_2, EQ8_3};
  parameter terms_len_string=60; //try to guess, terms plus the required spaces
  wire [terms_len_string:0] terms_all; //actual string to hold terms
  parameter terms_len_indv=8; //length of individual terms
  parameter num_eqs=3; //number of input equations
  parameter eq_len=36; //len of each eq ex [7:0] would be 8 to hold the extra bit
//call the solver, sort of hard coded

  ex8var #(terms_len_indv, terms_len_string) ex8var_test (EQ8_1[34:0],EQ8_2[34:0],EQ8_3[34:0],terms_all);
  //call the UART printer, uses parameters  
    UART_CALL #(eq_len,num_eqs,terms_len_indv,terms_len_string ) printer( terms_all, BTN[4:0], EQ_8s, CLK, UART_TXD);

    
endmodule
