`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/24/2024 03:42:31 PM
// Design Name: 
// Module Name: LUT2_2QuadDep
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module LUT2_2QuadDep(
input [6:0] two_linear_quad_independent,
output reg [16:0] Z1,
output reg [2:0] types
    );
     /* R Rest + xaxb + xaxc = RHS
    "Rest + Coeffs of eq1 + Coeffs of eq2 + RHS" : [(xa, xb, xc), (...)]*/
 
  reg [0:2][0:1] Zcoeff = {{1'b0,1'b0}, {1'b1,1'b0}, {1'b0,1'b1}};       // pairs of solution that for Zeros 
  reg [4:0] Zcoeff2=5'b001001;
  reg P = {1'b1,1'b0};                  //     # Any Pair; Don't Care
  reg ONE = {1'b1,1'b1};
  reg  MARKER=1'b1;
  
  /********************************************type list****************************/
 // type=0 {X, P}, {X,X,X}
 // type=1 {X,X,X}
 // type=2 {{X,P, P} {X,X,X}}
 // type=3 {{X,X,X}, {X,X,X}}
 // type=4 {{0,P,P}, {1,0,0}, {1,1,1}}
 
 //longest is 16
 //
/***********************************************************************************/
  always@(*) begin
  Z1=17'd0;
    case(two_linear_quad_independent)
        7'b0011000: begin types=2'd0; Z1[5:0]|={{1'b0,P}, {1'b1,1'b0,1'b0}}; Z1[6]|=MARKER; end
        7'b0011010: begin types=2'd1; Z1[2:0]|={1'b1,1'b0,1'b1}; Z1[3]|=MARKER;end
        7'b0011001: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b0}; Z1[3]|=MARKER;end
        7'b0011011: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b1};Z1[3]|=MARKER; end
        7'b0100100: begin types=2'd3; Z1[7:0]|={{1'b0,P,P}, {1'b1,1'b0,1'b0}};Z1[8]|=MARKER;end
        7'b0100110: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b0};Z1[3]|=MARKER; end
        7'b0100101: begin types=2'd1; Z1[2:0]|={1'b1,1'b0,1'b1};Z1[3]|=MARKER; end
        7'b0100111: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b1};Z1[3]|=MARKER; end
        7'b0001100: begin types=2'd2; Z1[7:0]|={{1'b0,P,P}, {1'b1,1'b1,1'b1}};Z1[8]|=MARKER;end
        7'b0001101: begin types=2'd3; Z1[5:0]|={{1'b1,1'b0,1'b1}, {1'b1,1'b1,1'b0}}; Z1[6]|=MARKER;end
        7'b0110000: begin types=2'd2; Z1[7:0]|={{1'b0,P,P}, {1'b1,1'b1,1'b1}}; Z1[8]|=MARKER;end
        7'b0110010: begin types=2'd3; Z1[5:0]|={{1'b1,1'b0,1'b1}, {1'b1,1'b1,1'b0}};Z1[6]|=MARKER; end
        7'b1011000: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b1}; Z1[3]|=MARKER;end
        7'b1011010: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b0};Z1[3]|=MARKER; end
        7'b1011001: begin types=2'd1; Z1[2:0]|={1'b1,1'b0,1'b1}; Z1[3]|=MARKER;end
        7'b1011011: begin types=2'd2; Z1[7:0]|={{1'b0,P,P}, {1'b1,1'b0,1'b0}}; Z1[8]|=MARKER;end
        7'b1100100: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b1}; Z1[3]|=MARKER;end
        7'b1100101: begin types=2'd1; Z1[2:0]|={1'b1,1'b1,1'b0};Z1[3]|=MARKER; end
        7'b1100110: begin types=2'd1; Z1[2:0]|={1'b1,1'b0,1'b1};Z1[3]|=MARKER; end
        7'b1100111: begin types=2'd3; Z1[5:0]|={{1'b1,1'b0,1'b1}, {1'b1,1'b0,1'b0}};Z1[6]|=MARKER; end
        7'b1110001: begin types=2'd2; Z1[5:0]|= {{1'b1,1'b1,1'b0}, {1'b1,1'b0,1'b1}};Z1[6]|=MARKER; end
        7'b1110011: begin types=2'd4; Z1[10:0]|={{1'b0,P,P}, {1'b1,1'b0,1'b0}, {1'b1,1'b1,1'b1}}; Z1[11]|=MARKER;end
        7'b1001110: begin types=2'd2; Z1[5:0]|= {{1'b1,1'b1,1'b0}, {1'b1,1'b0,1'b1}};Z1[6]|=MARKER; end
        7'b1001111: begin types=2'd4; Z1[10:0]={{1'b0,P,P}, {1'b1,1'b0,1'b0}, {1'b1,1'b1,1'b1}};Z1[11]|=MARKER; end
    endcase
    end
endmodule
