`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/24/2024 10:39:20 PM
// Design Name: 
// Module Name: LUT2_2QuadInd
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module LUT2_2QuadInd(
input [6:0] quads,
output reg [16:0] Z1,
output reg [2:0] types
    );
  reg [0:2][0:1] Zcoeff = {{1'b0,1'b0}, {1'b1,1'b0}, {1'b0,1'b1}};       // pairs of solution that for Zeros 
  reg [4:0] Zcoeff2=5'b001001;
  reg P = {1'b1,1'b0};                  //     # Any Pair; Don't Care
  reg ONE = {1'b1,1'b1};
  reg MARKER=1'b1;
  /* Rest + xaxb + xcxe= RHS
    "Rest + Coeffs of eq1 + Coeffs of eq2 + RHS" : [(xaxb, xcxe), (...)]
  */
    /********************************************type list****************************/
 // type=0 {Z,Z}
 // type=1 {Z,X,X} or some combination of
 // type=2 {X,X, X, X}
 // type=3 {{Z,Z}, {X,X,X,X}}
 
/***********************************************************************************/
 
    always @(*) begin
    Z1=17'd0;
    case(quads)
    7'b0011000: begin Z1[11:0]|={Zcoeff2,Zcoeff2}; Z1[12]|=MARKER;types=3'd0; end
    7'b0011010: begin Z1[7:0]|={Zcoeff2,1'b1, 1'b1}; types=3'd1;Z1[8]|=MARKER; end
    7'b0011001: begin Z1[7:0]|={1'b1,1'b1, Zcoeff2}; types=3'd1;Z1[8]|=MARKER; end
    7'b0011011: begin Z1[3:0]|=4'b1111; types=3'd2; Z1[4]|=MARKER;end
    7'b0100100: begin Z1[11:0]|={Zcoeff2,Zcoeff2}; types=3'd0;Z1[12]|=MARKER; end
    7'b0100110: begin Z1[7:0]|={1'b1, 1'b1, Zcoeff2}; types=3'd1;Z1[8]|=MARKER; end
    7'b0100101: begin Z1[7:0]|={Zcoeff2,1'b1, 1'b1}; types=3'd1;Z1[8]|=MARKER; end
    7'b0100111: begin Z1[3:0]|=4'b1111; Z1[4]|=MARKER;types=3'd2; end
    7'b0001100: begin Z1[15:0]|={4'b1111, Zcoeff2, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b0001101: begin Z1[15:0]|={Zcoeff2,4'b1111, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b0110000: begin Z1[15:0]|={4'b1111, Zcoeff2, Zcoeff2}; Z1[16]|=MARKER;types=3'd3; end
    7'b0110010: begin Z1[15:0]|={Zcoeff2,4'b1111, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b1011000: begin Z1[3:0]|=4'b1111; Z1[4]|=MARKER;types=3'd2; end
    7'b1011001: begin Z1[7:0]|={Zcoeff,1'b1, 1'b1}; Z1[8]|=MARKER;types=3'd1; end
    7'b1011010: begin Z1[7:0]|={1'b1, 1'b1, Zcoeff2}; Z1[8]|=MARKER;types=3'd1; end
    7'b1011011: begin Z1[11:0]|={Zcoeff2,Zcoeff2}; Z1[12]|=MARKER;types=3'd0; end
    7'b1100100: begin Z1[3:0]|=4'b1111;Z1[4]|=MARKER; types=3'd2; end
    7'b1100101: begin Z1[7:0]|={1'b1, 1'b1, Zcoeff2};Z1[8]|=MARKER; types=3'd1; end
    7'b1100110: begin Z1[7:0]|={Zcoeff,1'b1, 1'b1}; Z1[8]|=MARKER;types=3'd1; end
    7'b1100111: begin Z1[11:0]|={Zcoeff2,Zcoeff2};Z1[12]|=MARKER; types=3'd0; end
    7'b1110001: begin Z1[15:0]|={Zcoeff2,4'b1111, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b1110011: begin Z1[15:0]|={4'b1111,Zcoeff2, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b1001110: begin Z1[15:0]|={Zcoeff2,4'b1111, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    7'b1001111: begin Z1[15:0]={4'b1111,Zcoeff2, Zcoeff2};Z1[16]|=MARKER; types=3'd3; end
    endcase
    end
endmodule
