`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/24/2024 10:26:02 PM
// Design Name: 
// Module Name: LUT2_TwoCoeffMap
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module LUT2_TwoCoeffMap(
input [6:0] two_coeff_map,
output reg [16:0] Z1,

output reg [2:0] types
    );
    //constants
//reg [2:0] Zcoeff [1:0]= {{1'b0,1'b0}, {1'b1,1'b0}, {1'b0,1'b1}};       // pairs of solution that for Zeros 
reg P = {1'b1,1'b0};                  //     # Any Pair; Don't Care
reg ONE = {1'b1,1'b1};
reg MARKER=1'b1;
/************************Type variable and vars explanation**************/
//verilog needs to know exact size, this tells the function which output is valid
/*Zcoeff, P, and One are from the python coeffs

4'b0001=(Z,Z) output is of type [1:0]
4'b0010 or 4'd2 {{Z,Z},{Z,Z}} output is of type [1:0] [1:0]
/************************Type variable and vars explanation**************/
always @(*) begin
 /* Rest + xa + xb = RHS
    "Rest + Coeffs of eq1 + Coeffs of eq2 + RHS" : [(xa, xb), (...)]*/
    Z1=17'd0;
    case (two_coeff_map) 
        7'b0011000: begin Z1[1:0]|=2'b00; types=1'd0;Z1[2]|=MARKER; end
        7'b0011010: begin Z1[1:0]|=2'b01; types=1'd0;Z1[2]|=MARKER; end
        7'b0011001: begin Z1[1:0]|=2'b10; types=1'd0;Z1[2]|=MARKER; end
        7'b0011011: begin Z1[1:0]|=2'b11;Z1[2]|=MARKER; types=1'd0; end
        7'b0100100: begin Z1[1:0]|=2'b00;Z1[2]|=MARKER; types=1'd0; end
        7'b0100110: begin Z1[1:0]|=2'b10;Z1[2]|=MARKER; types=1'd0; end
        7'b0100101: begin Z1[1:0]|=2'b01; Z1[2]|=MARKER;types=1'd0; end
        7'b0100111: begin Z1[1:0]|=2'b11;Z1[2]|=MARKER; types=1'd0; end
        7'b0001100: begin Z1[3:0]|={{1'b1,1'b1},{1'b0,1'b0}}; Z1[4]|=MARKER;types=1'd1; end
        7'b0001101: begin Z1[3:0]|={{1'b0,1'b1},{1'b1,1'b0}}; Z1[4]|=MARKER;types=1'd1; end
        7'b0110000: begin Z1[3:0]|={{1'b1,1'b1},{1'b0,1'b0}};Z1[4]|=MARKER; types=1'd1; end 
        7'b0110010: begin Z1[3:0]|={{1'b0,1'b1},{1'b1,1'b0}};Z1[4]|=MARKER; types=1'd1; end 
        7'b1011000: begin Z1[1:0]|=2'b11; Z1[2]|=MARKER;types=1'd0; end 
        7'b1011001: begin Z1[1:0]|=2'b01;Z1[2]|=MARKER; types=1'd0; end
        7'b1011010: begin Z1[1:0]|=2'b10;Z1[2]|=MARKER;types=1'd0; end
        7'b1011011: begin Z1[1:0]|=2'b00;Z1[2]|=MARKER; types=1'd0; end
        7'b1100100: begin Z1[1:0]|=2'b11; Z1[2]|=MARKER;types=1'd0; end 
        7'b1100101: begin Z1[1:0]|=2'b10;Z1[2]|=MARKER; types=1'd0; end 
        7'b1100110: begin Z1[1:0]|=2'b01; Z1[2]|=MARKER;types=1'd0; end
        7'b1100111: begin Z1[1:0]|=2'b00; Z1[2]|=MARKER;types=1'd0; end
        7'b1110001: begin Z1[3:0]|={{1'b0,1'b1},{1'b1,1'b0}};Z1[4]|=MARKER; types=4'd2; end  
        7'b1110011: begin Z1[3:0]|={{1'b1,1'b1},{1'b0,1'b0}};Z1[4]|=MARKER; types=4'd2; end  
        7'b1001110: begin Z1[3:0]|={{1'b0,1'b1},{1'b1,1'b0}};Z1[4]|=MARKER; types=4'd2; end 
        7'b1001111: begin Z1[3:0]|={{1'b0,1'b1},{1'b0,1'b0}};Z1[4]|=MARKER; types=4'd2; end
        

endcase


end
endmodule