`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/24/2024 11:04:46 AM
// Design Name: 
// Module Name: LUT_2TwoLinearQuadInd
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module LUT_2TwoLinearQuadInd(
input [6:0] two_linear_quad_independent,
output reg [5:0] Z1,
output reg [3:0] Z2,
output reg [2:0] type
    );
   /* Rest + xa + xbxc = RHS  
    "Rest + Coeffs of eq1 + Coeffs of eq2 + RHS" : [(xa, xbxc), (...)]*/
 
  reg [0:2][0:1] Zcoeff = {{1'b0,1'b0}, {1'b1,1'b0}, {1'b0,1'b1}};       // pairs of solution that for Zeros 
  reg [4:0] Zcoeff2=5'b001001;
  reg P = {1'b1,1'b0};                  //     # Any Pair; Don't Care
  reg ONE = {1'b1,1'b1};
  /********************************************type list****************************/
 // type=0 {X, Zcoeff}
 // type=1 {X,X,X}
 // type=2
/***********************************************************************************/
  always@(*) begin
    case(two_linear_quad_independent)
        7'b0011000: begin type=2'd0; Z1={0, Zcoeff2}; end //0,Z
        7'b0011010: begin type=2'd1; Z2={0,1,1}; end
        7'b0011001: begin type=2'd0; Z1={1, Zcoeff2}; end 
        7'b0011011: begin[(1,1,1)],
    "0100100": [(0,Z)],
    "0100110": [(1,Z)],
    "0100101": [(0,1,1)],
    "0100111": [(1,1,1)],
    "0001100": [(1,1,1), (0,Z)],
    "0001101": [(0,1,1), (1,Z)],
    "0110000": [(1,1,1), (0,Z)],
    "0110010": [(0,1,1), (1,Z)],
    "1011000": [(1,1,1)],
    "1011001": [(0,1,1)],
    "1011010": [(1,Z)],
    "1011011": [(0,Z)],
    "1100100": [(1,1,1)],
    "1100101": [(1,Z)],
    "1100110": [(0,1,1)],
    "1100111": [(0,Z)],
    "1110001": [(0,1,1), (1,Z)],
    "1110011": [(1,1,1), (0,Z)],
    "1001110": [(0,1,1), (1,Z)],
    "1001111": [(1,1,1), (0,Z)]
    endcase
    end
endmodule
