`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/29/2024 02:35:06 PM
// Design Name: 
// Module Name: case3_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module case3_1(
    input reg [6:0] coeff,
    output reg [10:0] out  
); 

/** xa + xb + xc 
    Example: 
        Rest + xa + xb + xc, xa = 1, Rest = 0
        0 + 0*1 + 0*xb + 0*xc = 0 -> 0 + 0*xb + 0*xc = 0 
        0 + 1*1 + 1*xb + 1*xc = 0 -> 1*1 + 1*xb + 1*xc = 0
    "Rest + Coeff1 + Coeff2"
    Solution is [(new equation, xa=?),(...)]: [("R1 R2 Coeff1(2) Coeff2(2)", xa), (...)]
**/

always@(*)
begin 
out = 11'b0; 
    case(coeff)
    7'b0000111, 7'b0111000: 
        begin 
        //xa = 1
        // key_struct_1.transformed_coeff_1 = 6'b010011;

        //xa = 0
        // key_struct_1.transformed_coeff_0 = 5'b00011;
        out = 11'b01001100011;
        end 
    7'b0001110, 7'b0110001: 
        begin 
        // key_struct[0].xa = 1
        // key_struct_1.transformed_coeff_1 = 6'b010110;
        
        // key_struct[1].xa = 0
        // key_struct_1.transformed_coeff_0 = 5'b00110;
        out = 11'b01011000110;
        end 
    7'b0010101, 7'b0101010: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b011001;
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b01001;
        out = 11'b01100101001;
        end 
    7'b0011100, 7'b0100011: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b011100
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b01100
        out = 11'b01110001100;
        end 
    7'b1000111, 7'b1111000: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b100011
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b10011
        out = 11'b10001110011;
        end 
    7'b1001110, 7'b1110001: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b100110
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b10110
        out = 11'b10011010110;
        end
    7'b1010101, 7'b1101010: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b101001
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b11001
        out = 11'b10100111001;
        end 
    7'b1011100, 7'b1100011: 
        begin 
        // key_struct[0].xa = 1
        // key_struct[0].transformed_coeff_1 = 6'b101100
        
        // key_struct[1].xa = 0
        // key_struct[1].transformed_coeff_0 = 5'b11100
        out = 11'b10110011100;
        end 
    endcase
end
endmodule 
