module case3_3(
    input reg [6:0] coeff,
    output reg [8:0] out
); 

/* 
2 independent + 1 quad dependent
xa + xb + xaxc
    Example: 
        Rest + xa + xb + xaxc, xa = 1, Rest = 0
        0 + 0*1 + 0*xb + 0*1*xc = 0 -> 0 + 0*xb + 0*xc = 0 
        0 + 1*1 + 1*xb + 1*1*xc = 0 -> 1*1 + 1*xb + 1*xc = 0
    "Rest + Coeff1 + Coeff2"
    Solution is [(new eq1, eq2, xa=?),(...)]: [("R1 Coeff1" "R2 Coeff2", xa), (...)]
        "Rest xb xaxc(1*xc)", xa=1
        "Rest xb", xa=0 "R1 Coeff1 Coeff2"
*/

always@(*)
begin 
out = 9'b0; 
    case(coeff)
    7'b0000111, 7'b0111000:
        begin 
            // [(000,111,1),(001,0)]
            out = 9'b000111001;
        end 
    7'b0001110, 7'b0110001:
        begin 
            // [(001,110,1),(001,0)]
            out = 9'b001110001;
        end 
    7'b0010101, 7'b0101010:
        begin 
            // [(010,101,1),(010,0)]
            out = 9'b010101010;
        end 
    7'b0011100, 7'b0100011:
        begin 
            // [(011,100,1),(010,0)]
            out = 9'b011100010;
        end
    7'b1000111, 7'b1111000:
        begin
            // [(100,011,1),(101,0)]
            out = 9'b100011101;
        end 
    7'b1001110, 7'b1110001:
        begin
            // [(101,010,1),(101,0)]
            out = 9'b101010101;
        end
    7'b1010101, 7'b1101010:
        begin
            // [(110,001,1),(110,0)]
            out = 9'b110001110;
        end
    7'b1011100, 7'b1100011:
        begin
            // [(111,000,1),(110,0)]
            out = 9'b111000110;
        end
    endcase
end 
endmodule 