module case3_4(
    input reg [6:0] coeff,
    output reg [10:0] out 
); 

/*
#should be the same as case 1
2 independent + 1 quad independent
xa + xb + xcxd
    Example: 
        Rest + xa + xb + xcxd, xa = 1, Rest = 0
        0 + 0*1 + 0*xb + 0*xcxd = 0 -> 0 + 0*xb + 0*xcxd = 0 
        0 + 1*1 + 1*xb + 1*xcxd = 0 -> 1*1 + 1*xb + 1*xcxd = 0
    "Rest + Coeff1 + Coeff2"
    Solution is [(new eq1, eq2, xa=?),(...)]: [("R1 R2 Coeff1(2) Coeff2(2)", xa), (...)]
*/

always@(*)
begin 
out = 11'b0; 
    case(coeff)
    7'b0000111, 7'b0111000: 
        begin
            // (010011,1),(00011,0)
            out =11'b01001100011;
        end
    7'b0001110, 7'b0110001:
        begin
            // (010110,1),(00110,0)
            out =11'b01011000110;
        end
    7'b0010101, 7'b0101010:
        begin
            // (011001,1),(01001,0)
            out =11'b011001011001;
        end
    7'b0011100, 7'b0100011:
        begin
            // (011100,1),(01100,0)
            out =11'b01110001100;
        end
    7'b1000111, 7'b1111000:
        begin
            // (100011,1),(10011,0)
            out =11'b10001110011;
        end
    7'b1001110, 7'b1110001:
        begin
            // (100110,1),(10110,0)
            out =11'b10011010110;
        end
    7'b1010101, 7'b1101010:
        begin
            // (101001,1),(11001,0)
            out =11'b10100111001;
        end
    7'b1011100, 7'b1100011:
        begin
            // (101100,1),(11100,0)
            out =11'b10110011100;
        end
    endcase
end 
endmodule