module case3_5(
    input reg [6:0] coeff,
    output reg [5:0] out 
); 

//TODO what do we do about the 0 case since it just eliminates everything
//1 dependent + 2 mutually dependent quads
/* xa + xaxb + xaxc 
    Example: 
        Rest + xa + xaxb + xaxc, xa = 1, Rest = 0
        0 + 0*1 + 0*1*xb + 0*1*xc = 0 -> 0 + 0*xb + 0*xc = 0 
        0 + 1*1 + 1*1*xb + 1*1*xc = 0 -> 1*1 + 1*xb + 1*xc = 0
    "Rest + Coeff1 + Coeff2"
    Solution is [(new eq1, eq2, xa=?),(...)]: [("R1 R2 Coeff1(2) Coeff2(2)", xa), (...)]
*/


always@(*)
begin
out = 6'b0; 
    case(coeff)
    7'b0000111, 7'b0111000:
        begin
        // [(000,111,1),(,,0)],
            out=6'b000111;
        end
    7'b0001110, 7'b0110001:
        begin
        // [(001,110,1),(,,0)],
            out=6'b001110;
        end
    7'b0010101, 7'b0101010:
        begin
        // [(010,101,1),(,,0)],
            out=6'b010101;
        end
    7'b0011100, 7'b0100011:
        begin
        // [(011,100,1),(,,0)],
            out=6'b011100;
        end
    7'b1000111, 7'b1111000:
        begin
        // [(100,011,1),(,,0)],
            out=6'b100011;
        end
    7'b1001110, 7'b1110001:
        begin
        // [(101,010,1),(,,0)],
            out=6'b101010;
        end
    7'b1010101, 7'b1101010:
        begin
        // [(110,001,1),(,,0)],
            out=6'b110001;
        end
    7'b1011100, 7'b1100011:
        begin
        // [(111,000,1),(,,0)]
            out=6'b111000;
        end
    endcase
end
endmodule