`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 02/21/2024 02:17:58 PM
// Design Name: 
// Module Name: new_RHS
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module new_RHS(
    input reg RHS1, 
    input reg RHS2, 
    input reg rest,
    input reg eq1_0, //eq1[0]
    input reg eq1_1, //eq1[1]
    input reg eq2_0, //eq2[0]
    input reg eq2_bool,
    output reg nR1, 
    output reg nRHS1, 
    output reg nRHS2
); 

     /*** RHS_REST ***/
    wire nR1;
    wire nRHS1;
    wire nRHS2;
always @(*) begin
    // get new rest from equations
    nR1 = (rest ^ eq1_0);

    if (eq2_bool == 1'b1) begin
        nR2 = (rest ^ eq2_0);
        // eq = eq1[1:] + eq2[1:];
    end else begin
        nR2 = (rest ^ eq1_1);
        // eq = eq1[1:];
    end 
    
    // if not the same rest we are going to XOR it to RHS because we can
    if(nR1 != nR2) begin
        // xor mod add 
        nRHS1 = (RHS1 ^ nR1);
        nRHS2 = (RHS2 ^ nR2);
        // set new rest 
        nR1 = 1'b0;
        nR2 = 1'b0;
    end 
    end
    endmodule
